from redis.exceptions import ResponseError

from bsition.backend.redis.utils import get_client

max_tokens = 10


def add_token(token, username):
    client = get_client()
    try:
        client.bf().reserve(username, 0.01, max_tokens, noScale=True)
    except ResponseError:
        pass

    if client.bf().info(username).insertedNum == max_tokens:
        remove_tokens(username)

    client.bf().add(username, token)


def remove_tokens(username):
    client = get_client()
    client.unlink(username)


def valid_token(token, username):
    client = get_client()
    return client.bf().exists(username, token) == 1
